<?php
/******************************************************************************
 *
 * Subrion - open source content management system
 * Copyright (C) 2015 Intelliants, LLC <http://www.intelliants.com>
 *
 * This file is part of Subrion.
 *
 * Subrion is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * Subrion is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Subrion. If not, see <http://www.gnu.org/licenses/>.
 *
 *
 * @link http://www.subrion.org/
 *
 ******************************************************************************/

$iaMailerPlugin = $iaCore->factoryPlugin('mailer', iaCore::ADMIN, 'mailerplugin');

if (iaView::REQUEST_HTML == $iaView->getRequestType())
{
	if (!empty($_GET['action']))
	{
		$messages = array();
		$id = empty($_GET['id']) ? -1 : (int)$_GET['id'];

		switch ($_GET['action'])
		{
			case 'toggleQueue':
				$iaMailerPlugin->toggleQueue($id);

				$messages[] = iaLanguage::get('saved');

				break;

			case 'remove':
				$iaMailerPlugin->removeQueue($id);

				$messages[] = iaLanguage::get('queue_removed');
		}

		$iaView->setMessages($messages, iaView::SUCCESS);
	}
}

if (iaView::REQUEST_HTML == $iaView->getRequestType())
{
	if (iaCore::ACTION_ADD == $pageAction)
	{
		$html = 0;

		if (isset($_POST['save']))
		{
			if($_POST['type'] == 'text')
			{
				$body = str_replace("'", "\'", $_POST['body']);
			}
			else
			{
				$body = str_replace("'", "\'", $_POST['html_body']);
				$html = 1;
			}

			list($error, $msg) = $iaMailerPlugin->createQueue($_POST['from_name'], $_POST['from_mail'], $_POST['subj'], $body, $html, $_POST['groups'], $_POST['st']);
			$iaView->setMessages($msg, ($error ? iaView::ERROR : iaView::SUCCESS));

			if (!$error)
			{
				$iaUtil = iaCore::util();
				iaUtil::go_to(IA_ADMIN_URL . 'mailer/');
			}
		}

		if (empty($_POST))
		{
			$data = array(
				'from_name' => iaUsers::getIdentity()->fullname,
				'from_mail' => iaUsers::getIdentity()->email,
				'type' => 'html',
				'subj' => '',
				'body' => ''
			);
		}
		else
		{
			$data = $_POST;
		}

		$statuses = $iaMailerPlugin->getAccountsStatusList();

		$iaView->assign('data', $data);
		$iaView->assign('statuses', $statuses);
		$iaView->assign('usergroups', $iaCore->factory('users')->getUsergroups());
		$iaView->assign('check', (!empty($_POST['type']) && 'html' == $_POST['type'] ? true : false));
	}
	else
	{
		if ($queue = $iaMailerPlugin->getQueues())
		{
			$iaView->assign('queue', $queue);
		}
	}
}