<?php
/******************************************************************************
 *
 * Subrion - open source content management system
 * Copyright (C) 2015 Intelliants, LLC <http://www.intelliants.com>
 *
 * This file is part of Subrion.
 *
 * Subrion is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * Subrion is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Subrion. If not, see <http://www.gnu.org/licenses/>.
 *
 *
 * @link http://www.subrion.org/
 *
 ******************************************************************************/

if ($queue = $iaDb->row(iaDb::ALL_COLUMNS_SELECTION, null, 'mailer_recipients'))
{
	$iaDb->setTable('mailer_messages');

	$iaMailer = $iaCore->factory('mailer');

	$recipients = explode(',', $queue['recipients']);
	$stmt = '`id` = :id AND `active` = :status';
	$iaDb->bind($stmt, array('id' => $queue['message_id'], 'status' => 1));
	if ($m = $iaDb->row(iaDb::ALL_COLUMNS_SELECTION, $stmt))
	{
		if ($m['html'])
		{
			$iaMailer->isHTML(true);
		}

		$iaMailer->clearAddresses();
		$iaMailer->FromName = $m['from_name'];
		$iaMailer->From = $m['from_mail'];
		$iaMailer->Subject = $m['subj'];
		$iaMailer->Body = $m['body'];

		foreach($recipients as $email)
		{
			$iaMailer->addAddress($email);
		}

		$iaMailer->send();

		$iaDb->delete(iaDb::convertIds($queue['id']), 'mailer_recipients');

		$iaDb->exists('`message_id` =  ' . $m['id'], null, 'mailer_recipients')
			? $iaDb->update(null, '`id` = ' . $m['id'], array('total' => '`total` - ' . count($recipients)))
			: $iaDb->delete(iaDb::convertIds($m['id']));
	}

	$iaDb->resetTable();
}